var util = require('util')
var stream = require('stream')

// http://javascript0.org/wiki/Portable_sendAsBinary
function SendAsBinary() {
  this.writable = true
  this.readable = true
}

util.inherits(SendAsBinary, stream.Stream)

SendAsBinary.prototype.write = function(chunk) {
  var ords = Array.prototype.map.call(chunk, this.byteValue)
  var ui8a = new Uint8Array(ords)
  this.emit('data', ui8a.buffer)
}

SendAsBinary.prototype.byteValue = function(x) {
  return x.charCodeAt(0) & 0xff
}
 
SendAsBinary.prototype.end = function(chunk) { this.emit('end') }

module.exports = function() {
  return new SendAsBinary()
}

module.exports.SendAsBinary = SendAsBinary
